<template>
  <v-data-table
    :headers="headers"
    :items="desserts"
    sort-by="createdAt"
    class="elevation-1"
    :loading="loading"
    loading-text="Загрузка... Пожалуйста ждите"
  >
    <template v-slot:item.color="{ item }">
      <v-chip
        :color="item.color"
        dark
      >
        {{ item.name }}
      </v-chip>
    </template>
    <template v-slot:item.createdAt="{ item }">
      <p>{{formatDate(item.createdAt, true)}}</p>
    </template>
    <template v-slot:item.updatedAt="{ item }">
      <p>{{formatDate(item.updatedAt, true)}}</p>
    </template>
    <template v-slot:top>
      <v-toolbar
        flat
      >
        <v-toolbar-title>Управление шаблонами</v-toolbar-title>
        <v-divider
          class="mx-4"
          inset
          vertical
        ></v-divider>
        <v-spacer></v-spacer>
        <v-dialog
          v-model="dialog"
          max-width="500px"
        >
          <template v-slot:activator="{ on, attrs }">
            <v-btn
              color="primary"
              dark
              class="mb-2"
              v-bind="attrs"
              v-on="on"
            >
              Создать шаблон
            </v-btn>
          </template>
          <v-card>
            <v-card-title>
              <span class="text-h5">{{ formTitle }}</span>
            </v-card-title>

            <v-card-text>
              <v-container>
                <v-row>
                  <v-col
                    cols="12"
                  >
                    <v-text-field
                      v-model="editedItem.name"
                      label="Название шаблона"
                    ></v-text-field>
                  </v-col>
                  <v-col
                    cols="12"
                  >
                    <v-textarea
                      v-model="editedItem.sms"
                      label="Текст шаблона"
                    />
                  </v-col>
                  <v-col
                    cols="12"
                  >
                    <p class="text-center">Цвет Шаблона</p>
                    <v-color-picker
                      v-model="editedItem.color"
                      flat
                      hide-inputs
                      class="mx-auto"
                    ></v-color-picker>
                  </v-col>
                  <v-col
                    cols="12"
                  >
                    <div class="d-flex align-center">
                      <p class="text-center mt-3 mr-3 text-h6">Видимость шаблона: </p>
                      <v-switch v-model="editedItem.visible" :label="editedItem.visible && 'виден' || 'скрыт'"/>
                    </div>
                  </v-col>
                </v-row>
              </v-container>
            </v-card-text>

            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn
                color="blue darken-1"
                text
                @click="close"
              >
                Закрыть
              </v-btn>
              <v-btn
                color="blue darken-1"
                text
                @click="save"
                :loading="loadingEditButton"
              >
                Сохранить
              </v-btn>
            </v-card-actions>
          </v-card>
        </v-dialog>
        <v-dialog v-model="dialogDelete" max-width="500px">
          <v-card>
            <v-card-title class="text-h5 justify-center">Удалить этот шаблон?</v-card-title>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="blue darken-1" text @click="closeDelete">Отмена</v-btn>
              <v-btn :loading="loadingDeleteButton" color="red darken-1" text @click="deleteItemConfirm">Удалить</v-btn>
              <v-spacer></v-spacer>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </v-toolbar>
    </template>
    <template v-slot:item.actions="{ item }">
      <v-icon
        small
        class="mr-2"
        @click="editItem(item)"
      >
        mdi-pencil
      </v-icon>
      <v-icon
        small
        @click="deleteItem(item)"
      >
        mdi-delete
      </v-icon>
    </template>
    <template v-slot:no-data>
      <v-btn
        color="primary"
        @click="initialize"
      >
        Перезагрузить
      </v-btn>
    </template>
  </v-data-table>
</template>

<script>
import api from '@/API/api'
import formatDate from "./utils/formatDate";

export default {
  name: 'TemplateSMS',
  data: () => ({
    dialog: false,
    dialogDelete: false,
    loading: false,
    loadingEditButton: false,
    loadingDeleteButton: false,
    name: "",
    sms: "",
    color: "",
    visible: true,
    headers: [
      {
        text: 'Название',
        align: 'start',
        sortable: false,
        value: 'name',
      },
      { text: 'Цвет', value: 'color' },
      { text: 'Дата создания', value: 'createdAt' },
      { text: 'Дата изменения', value: 'updatedAt' },
      { text: 'Действия', value: 'actions' },
    ],
    desserts: [],
    editedIndex: -1,
    editedItem: {
      name: "",
      sms: "",
      color: "",
      visible: true,
    },
    defaultItem: {
      name: "",
      sms: "",
      color: "",
      visible: true,
    },
  }),

  computed: {
    formTitle () {
      return this.editedIndex === -1 ? 'Новый шаблон' : 'Редактирование шаблона'
    },
  },

  watch: {
    dialog (val) {
      val || this.close()
    },
    dialogDelete (val) {
      val || this.closeDelete()
    },
  },

  created () {
    this.initialize()
  },

  methods: {
    formatDate,
    async initialize () {
      this.loading = true
      await api.getTemplateSMS()
        .then(res => {
          console.log(res.data.template)
          console.log(res.data.template || [])
          this.desserts = res.data.template || []
          this.loading = false
        })
        .catch(() => {
          this.loading = false
          this.desserts = []
        })
    },

    editItem (item) {
      this.editedIndex = this.desserts.indexOf(item)
      this.editedItem = Object.assign({}, item)
      this.dialog = true
    },

    deleteItem (item) {
      this.editedIndex = this.desserts.indexOf(item)
      this.editedItem = Object.assign({}, item)
      this.dialogDelete = true
    },

    async deleteItemConfirm () {
      this.loadingDeleteButton = true
      this.desserts.splice(this.editedIndex, 1)
      await api.deleteTemplateSMS({_id: this.editedItem._id})
      .then(res => {
        res.data.status && (this.loadingDeleteButton = false)
        this.closeDelete()
      })
    },

    close () {
      this.dialog = false
      this.$nextTick(() => {
        this.editedItem = Object.assign({}, this.defaultItem)
        this.editedIndex = -1
      })
    },

    closeDelete () {
      this.dialogDelete = false
      this.$nextTick(() => {
        this.editedItem = Object.assign({}, this.defaultItem)
        this.editedIndex = -1
      })
    },

    async save () {
      this.loadingEditButton = true
      if (this.editedIndex > -1) {
        const item = this.desserts[this.editedIndex]
        Object.assign(item, this.editedItem)
        await api.changeTemplateSMS({
          _id: this.editedItem._id,
          name: this.editedItem.name,
          sms: this.editedItem.sms,
          color: this.editedItem.color,
          visible: this.editedItem.visible,
        })
        .then(res => res.data.status && (this.loadingEditButton = false))
      } else {
        this.desserts.push(this.editedItem)
        await api.addTemplateSMS({
          name: this.editedItem.name,
          sms: this.editedItem.sms,
          color: this.editedItem.color,
          visible: this.editedItem.visible,
        })
        .then(res => res.data.status && this.initialize())
        this.loadingEditButton = false
      }
      this.close()
    },
  },
}
</script>

<style scoped>

</style>
